projtool/usertool: default paging to off for most commands
[girocco/readme.git] / jobd / gc.sh
blobf6a1a4e019a4f7d8806dc383acc03367058be5fa
1 #!/bin/sh
3 # NOTE: additional options can be passed to git repack by specifying
4 # them after the project name, for example:
5 # gc.sh my-project -f
7 . @basedir@/shlib.sh
8 . @basedir@/jobd/gc-util-functions.sh
10 set -e
12 if [ $# -lt 1 ]; then
13 echo "Usage: gc.sh projname [extra-repack-args]" >&2
14 exit 1
17 # Includes
18 _shlib_done=1
19 unset GIROCCO_SUPPRESS_AUTO_GC_UPDATE
20 . "$cfg_basedir/jobd/maintain-auto-gc-hack.sh"
21 . "$cfg_basedir/jobd/generate-auto-gc-update.sh"
22 GIROCCO_SUPPRESS_AUTO_GC_UPDATE=1 && export GIROCCO_SUPPRESS_AUTO_GC_UPDATE
24 umask 002
25 [ "$cfg_permission_control" != "Hooks" ] || umask 000
26 clean_git_env
28 # The pre-receive script creates one ref log file per push but we want them to
29 # be coalesced into one ref log file per day. We are guaranteed that any files
30 # we find to coalesce are NOT currently being written to since they are always
31 # written first as temporary files and then moved into place. We attempt to
32 # transfer the most recent modification time to the coalesced log file which
33 # would step on its mod time if it were being written to directly, but if we
34 # find per-process ref log files then it must be a push project and the only
35 # thing that would write directly to the main per-day log file would be a
36 # mirror project so there's actually no conflict.
37 # Also, if the clock is wonky (or was futzed with) we may have both YYYYMMDD
38 # and YYYYMMDD.gz present in which case combine them into YYYYMMDD
39 coalesce_reflogs() {
40 [ -d reflogs ] || return 0
41 rm -f .gc_failed
42 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
43 while read -r rname; do
44 if [ -e "$rname.gz" ]; then
45 if [ -s "$rname" ]; then
46 # Presumably the .gz file must have been created before the non-gz
47 # file since it had to be uncompressed at some point therefore
48 # we need to append the non-gz contents to it but keep the non-gz
49 # contents timestamp so we rename to YYYYMMDD_ which will sort first
50 # and be picked up in the next step if we are interrupted in the middle.
51 # If a YYYYMMDD_ file already exists we append to it and transfer the
52 # timestamp. Finally we transfer the YYYYMMDD_ timestamp to the result
53 # and remove the YYYYMMDD_ temporary file leaving the result uncompressed.
54 if [ -e "${rname}_" ]; then
55 cat "$rname" >>"${rname}_"
56 touch -r "$rname" "${rname}_"
57 rm -f "$rname"
58 ! [ -e "$rname" ]
59 else
60 mv "$rname" "${rname}_"
62 gzip -d "$rname.gz" </dev/null
63 [ -e "$rname" ] && ! [ -e "$rname.gz" ]
64 cat "${rname}_" >>"$rname"
65 touch -r "${rname}_" "$rname"
66 rm -f "${rname}_"
67 else
68 # Just remove the empty file to resolve the problem
69 rm -f "$rname"
72 done
73 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]_*" -print | LC_ALL=C sort |
74 while read -r rname; do
75 logname="${rname%%_*}"
76 # If someone's been futzing with the date, the file we want to
77 # append to could already have been compressed, so we just uncompress
78 # it here. The previous block guarantees we do not have both a compressed
79 # and uncompressed version present at the same time.
80 if [ -e "$logname.gz" ]; then
81 gzip -d "$logname.gz" </dev/null
82 [ -e "$logname" ] && ! [ -e "$logname.gz" ]
84 cat "$rname" >>"$logname"
85 touch -r "$rname" "$logname"
86 rm -f "$rname"
87 if [ -e "$rname" ]; then
88 >.gc_failed
89 echo "! [$proj] failed to remove $rname" >&2
90 exit 1 # will only exit subshell created by "|"
92 done
93 ! [ -e .gc_failed ]
96 # Remove any files in reflogs that are older than $cfg_reflogs_lifetime days
97 prune_reflogs() {
98 [ -d reflogs ] || return 0
99 exp="$(( ${cfg_reflogs_lifetime:-1} * 1440 ))"
100 [ $exp -gt 0 ] || exp=1440
101 [ $exp -le 43200 ] || exp=43200
102 find -L reflogs -maxdepth 1 -type f -mmin "+$exp" -exec rm -f '{}' + || :
105 # Compact any reflogs that are not today's UTC date unless a .gz version exists
106 compact_reflogs() {
107 [ -d reflogs ] || return 0
108 _td="reflogs/$(TZ=UTC date '+%Y%m%d')"
109 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
110 while read -r rname; do
111 [ "$rname" != "$_td" ] || continue
112 ! [ -e "$rname.gz" ] || continue
113 gzip -9 "$rname" </dev/null
114 done
117 # return true if there's more than two objects/pack-<sha>.pack files or
118 # ANY sha-1 files in objects or
119 # there's one or two packs but at least one does not have a normal pack name or
120 # there's at least one pack but not any refs
121 is_dirty() {
122 _packs="$(find -L objects/pack -name "pre-auto-gc-[12].pack" -prune -o -name "*.pack" -type f -print 2>/dev/null | head -n 3)"
123 v_cnt _packscnt $_packs
124 if [ $_packscnt -gt 2 ]; then
125 return 0
127 if [ $_packscnt -gt 0 ]; then
128 for _pack in $_packs; do
129 _pack="${_pack%.pack}"
130 _pack="${_pack#objects/pack/}"
131 case "$_pack" in
132 pack-*)
133 _pack="${_pack#pack-}"
134 if [ "${#_pack}" -lt 40 ] || [ "${_pack#*[!0-9a-fA-F]}" != "$_pack" ]; then
135 # name not exclusively 40 or more hexadecimal digits makes it dirty
136 return 0
140 # abnormal name makes it dirty
141 return 0
143 esac
144 done
146 _objs=$(find -L objects/$octet -name "$octet19*" -type f -print 2>/dev/null | head -n 1 | LC_ALL=C wc -l)
147 [ $_objs -eq 0 ] || return 0
148 [ $_packscnt -gt 0 ] || return 1
149 # we do this check last because it's potentially the most expensive;
150 # at this point we know we do not have any loose objects, but we do
151 # have one or two packs that are named "normally"; empty refs => dirty
152 is_empty_refs_dir
155 # combine the input pack(s) into a new pack (or possibly packs if packSizeLimit set)
156 # input pack names are read from standard input one per line delimited by the first
157 # ':', ' ' or '\n' character on the line (which allows gfi-packs to be read directly)
158 # all arguments, if any, are passed to pack-objects as additional options
159 # returns non-zero on failure AND creates .gc_failed in that case
160 combine_packs() {
161 rm -f .gc_failed
162 combine_packs_std "$@" || {
163 >.gc_failed
164 return 1
166 return 0
169 # if the current directory is_gfi_mirror then repack all packs listed in gfi-packs
170 repack_gfi_packs() {
171 [ -n "$gfi_mirror" ] || return 0
172 [ -d objects/pack ] || { rm -f gfi-packs; return 0; }
173 progress "~ [$proj] redeltifying poor quality git fast-import packs"
174 combine_packs --ignore-missing --no-reuse-delta <gfi-packs
175 rm -f gfi-packs
176 return 0
179 # pack any existing loose objects into a new _l.pack file then run prune-packed
180 # note that prune-packed is NOT run beforehand -- the caller must do that if needed
181 # loose objects need not be part of complete commits/trees as --weak-naming is used
182 pack_loose_objects() {
183 _lpacks="$(run_combine_packs </dev/null --names --loose --weak-naming --non-empty --all-progress-implied ${quiet:---progress} $packopts)"
184 if [ -n "$_lpacks" ]; then
185 # We need to identify these packs later so we don't combine_packs them
186 for _objpack in $_lpacks; do
187 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
188 done
189 git prune-packed $quiet
193 # combine small packs into larger pack(s)
194 # we avoid any _[lo], keep, bndl or bitmap packs
195 # if the optional argument is non-empty even a single small pack will be redeltad
196 combine_small_packs() {
197 _didprogress=
198 _minsmallpacks=2
199 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
200 _minsmallpacks=1
202 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
203 _lpo="$_lpo --exclude-sfx _u --exclude-sfx _o --exclude-sfx _l"
204 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
205 while
206 _cnt="$(list_packs --count $_lpo)" || :
207 test "${_cnt:-0}" -ge $_minsmallpacks
209 [ -n "$_didprogress" ] || {
210 progress "~ [$proj] combining small packs into a single larger pack"
211 _didprogress=1
213 _newp="$(list_packs $_lpo | combine_packs --names $noreusedeltaopt)"
214 v_cnt _newc $_newp
215 # be paranoid and exit the loop if we haven't reduced the number of packs
216 [ $_newc -lt $_cnt ] || break
217 _minsmallpacks=2
218 done
219 return 0
222 # combine small _l packs into larger pack(s) using --weak-naming
223 # we avoid any non _l, keep, bndl or bitmap packs
224 # if the optional 2nd argument is non-empty even a single small pack will be redeltad
225 combine_small_loose_packs() {
226 _didprogress=
227 _minsmallpacks=2
228 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
229 _minsmallpacks=1
231 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
232 _lpo="$_lpo --exclude-no-sfx _l"
233 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
234 while
235 _cnt="$(list_packs --count $_lpo)" || :
236 test "${_cnt:-0}" -ge $_minsmallpacks
238 [ -n "$_didprogress" ] || {
239 progress "~ [$proj] combining small loose packs into a single larger pack"
240 _didprogress=1
242 _newp="$(list_packs $_lpo | combine_packs --names --weak-naming $noreusedeltaopt)"
243 # We need to identify these packs later so we don't combine_packs them
244 for _objpack in $_newp; do
245 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
246 done
247 v_cnt _newc $_newp
248 # be paranoid and exit the loop if we haven't reduced the number of packs
249 [ $_newc -lt $_cnt ] || break
250 _minsmallpacks=2
251 done
252 return 0
255 # Unfortunately, some fetch strategies (e.g. git-svn and non-smart HTTP) lack
256 # the ability to store newly fetched objects in a pack.
257 # However, the fetch code conveniently sets .needspack just before it fetches
258 # so that it's easy to find all the loose objects that have been fetched and
259 # combine them into a pack. The --no-reuse-delta option is meaningless here
260 # since everything to be packed is a loose object and therefore not a delta so
261 # deltification will always take place.
262 make_needs_pack() {
263 [ -f .needspack ] || return 0
264 rm -f .needspackgc
265 mv -f .needspack .needspackgc
266 progress "~ [$proj] combining fetched loose objects into a pack"
267 _newp="$(find -L objects/$octet -maxdepth 1 -type f -newer .needspackgc -name "$octet19*" -print 2>/dev/null |
268 LC_ALL=C awk -F / '{print $2 $3}' |
269 run_combine_packs --objects --names $packopts --incremental --all-progress-implied $quiet --non-empty)" || {
270 # We used to fail gc here.
271 # Now, however, we just ignore the failure because we have
272 # another mechanism to handle loose objects and it's possible
273 # that the fetcher somehow brought in unconnected objects which
274 # would cause the above combine-packs to fail.
275 # By ignoring the failure and just removing the .needspack file
276 # the loose objects will be treated as "ordinary" loose objects
277 # and packed using the "--weak-naming" option which can handle
278 # broken connectivity.
279 # That's a better solution than just failing here or leaving
280 # .needspack behind to potentially continue to fail again and
281 # again.
282 _newp=
283 # combine-packs.sh will have output a nasty fatal message,
284 # ameliorate it with a follow up to say that all is okay
285 echo "gc: bad needs_pack connectivity, using --weak-naming: $proj" >&2
287 if [ -n "$_newp" ]; then
288 # remove the now-redundant loose objects -- this is always safe
289 # even during a concurrent push because a reprepare_packed_git
290 # will be triggered if an object that should be there is not
291 # found thereby finding it in the new pack instead
292 git prune-packed $quiet
294 rm -f .needspackgc
297 # HEADSHA="$(pack_is_complete /full/path/to/some.pack /full/path/to/packed-refs "$(cat HEAD)")"
298 pack_is_complete() {
299 # Must have a matching .idx file and a non-empty packed-refs file
300 [ -s "${1%.pack}.idx" ] || return 1
301 [ -s "$2" ] || return 1
302 _headsha=
303 case "$3" in
304 $octet20*)
305 _headsha="$3"
307 "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
308 _headmatch="${3#ref:}"
309 _headmatch="${_headmatch# }"
310 _headmatchpat="$(echo "$_headmatch" | LC_ALL=C sed -e 's/\([.$]\)/\\\1/g')"
311 _headsha="$(LC_ALL=C grep -e "^$octet20$hexdig* $_headmatchpat\$" <"$2" |
312 LC_ALL=C cut -d ' ' -f 1)"
313 case "$_headsha" in $octet20*) :;; *)
314 return 1
315 esac
318 # bad HEAD
319 return 1
320 esac
321 rm -rf pack_is_complete_test
322 mkdir pack_is_complete_test
323 mkdir pack_is_complete_test/refs
324 mkdir pack_is_complete_test/objects
325 mkdir pack_is_complete_test/objects/pack
326 echo "$_headsha" >pack_is_complete_test/HEAD
327 ln -s "$1" pack_is_complete_test/objects/pack/
328 ln -s "${1%.pack}.idx" pack_is_complete_test/objects/pack/
329 ln -s "$2" pack_is_complete_test/packed-refs
330 _count="$(git --git-dir=pack_is_complete_test rev-list --count --all 2>/dev/null)" || :
331 rm -rf pack_is_complete_test
332 [ -n "$_count" ] || return 1
333 [ "$_count" -gt 0 ] 2>/dev/null || return 1
334 echo "$_headsha"
337 # write the hexadecimal sha256 hash of stdin plus a trailing newline to stdout
338 sig_hash_stdin() {
339 "$cfg_basedir/bin/ltsha256"
342 # Compute a "signature" for the refs in the specified (default .) repository.
343 # Instead of passing --head to show-ref, the actual contents of HEAD are used
344 # to capture changes in HEAD's symbolic-ref value that would otherwise be missed.
345 # $1 => variable name to store result hash in
346 # $2 => --git-dir to use, defaults to "."
347 v_compute_refs_sighash() {
348 eval "$1="'"$({ cat "${2:-.}/HEAD"; git --git-dir="${2:-.}" show-ref; } |
349 sig_hash_stdin)"'
352 # On return a "$lockf" will have been created that must be removed when gc is done
353 lock_gc() {
354 v_lock_gc _lockresult || {
355 echo >&2 "[$proj] $_lockresult"
356 exit 1
358 lockf="$_lockresult"
361 # Create a repack subdirectory such that running repack in it will pack the
362 # same things that a pack in the normal directory would except that the pack
363 # is guaranteed to be generated in an optimized order by adding a suitable
364 # synthesized ref in the refs/tags namespace (yes, pack-objects.c really does
365 # behave differently depending on the contents of the refs/tags namespace).
366 # Before calling this, pack-refs --all MUST be performed or the wrong pack
367 # will end up being made.
369 # If a ref deletion is pushed after making the repack subdir but before the
370 # the actual repack, the discarded objects will be packed -- no big deal,
371 # they'll get discarded the next time gc runs.
373 # If a fast-forward ref update is pushed after making the repack subdir but
374 # before the actual repack, it will be picked up and the new objects packed
375 # (subject to the normal git repack race about picking such updates up).
377 # If a non-fast-forward ref update is pushed after making the repack subdir but
378 # before the actual repack, it will be picked up like a fast-forward update but
379 # the discarded objects will be included like a ref deletion (until the next
380 # scheduled gc takes place).
382 # We retain a copy of the original packed-refs file as repack/packed-refs.orig
383 # If ref deletions come in while we're repacking, the original packed-refs
384 # file will be modified, but we'll still pack the deleted ref(s).
385 # If the packed-refs.orig file is used to create the bundle header we avoid
386 # a situation where the bundle contains a ref state that never actually
387 # existed in reality (for example a new branch is pushed and then an old
388 # branch deleted afterwards -- the deletion would show up in the bundle
389 # because it will cause the original packed-refs file to be re-written, but
390 # the new branch creation will not unless we do another pack-refs which might
391 # lead to having in incomplete bundle). Therefore we want to keep a copy of
392 # the original packed-refs file around. We do the same thing for HEAD.
394 # It's possible that the "objects" subdirectory is a symbolic link.
395 # Git does support this. However, during the repacking process, new packs
396 # will be created in repack/alt/pack and then moved into objects/pack.
397 # In order for this to work seemlessly, they must both be on the same
398 # filesystem. But when objects (or even objects/pack) is a symbolic link they
399 # might not be. For this reason a "repack" subdirectory is created under
400 # objects/pack and the repack/alt/pack directory symbolicly linked to it.
402 # Git allows not just HEAD to be a symbolic-ref, but any ref anywhere in the
403 # refs namespace. We are concerned about ref name collisions and getting the
404 # right tag set to get an optimal pack. We can safely duplicate the ref space
405 # under refs/heads, refs/notes and refs/remotes without any risk of unwanted
406 # collisions and this will likely make over 99%+ of all symbolic refs found
407 # in the wild work properly. Girocco itself never creates any symbolic refs
408 # inside the refs namespace; this is a nod to simultaneously using a Girocco
409 # repository for other purposes.
410 make_repack_dir() {
411 ! [ -d repack ] || rm -rf repack
412 ! [ -d repack ] || { echo >&2 "[$proj] cannot remove repack subdirectory"; exit 1; }
413 [ -d objects/pack ] || mkdir -p objects/pack
414 ! [ -d objects/pack/repack ] || rm -rf objects/pack/repack
415 ! [ -d objects/pack/repack ] || { echo >&2 "[$proj] cannot remove objects/pack/repack subdirectory"; exit 1; }
416 mkdir repack repack/refs repack/alt objects/pack/repack
417 [ -d info ] || mkdir info
418 ln -s ../config repack/config
419 ln -s ../info repack/info
420 ln -s ../objects repack/objects
421 ln -s "$PWD/objects/pack/repack" repack/alt/pack
422 ! [ -d logs ] || ln -s ../logs repack/logs
423 ! [ -d worktrees ] || ln -s ../worktrees repack/worktrees
424 _lines=$(( $(LC_ALL=C wc -l <packed-refs) ))
425 cat HEAD >repack/HEAD.orig
426 cat packed-refs >repack/packed-refs.orig
427 ln -s packed-refs.orig repack/packed-refs
428 cp repack/HEAD.orig repack/HEAD
429 v_compute_refs_sighash _rsig repack
430 rm repack/packed-refs repack/HEAD
431 ln -s ../../refs repack/refs/refs
432 echo "$_rsig" >repack/packed-refs.sighash
433 >repack/packed-refs.extra
434 _xtralines=0
435 if [ $(LC_ALL=C wc -l <repack/packed-refs.orig) -ne "$_lines" ]; then
436 echo >&2 "[$proj] error: make_repack_dir failed original packed-refs line count sanity check"
437 exit 1
439 if [ "${cfg_fetch_stash_refs:-0}" = "0" ]; then
440 # migrate any refs/stash or refs/tgstash lines to repack/packed-refs.extra
441 <repack/packed-refs.orig LC_ALL=C awk -v xtra="repack/packed-refs.extra" '
442 BEGIN { peeling = 0 }
443 NR == 1 && /^#/ { print; next; }
444 peeling && /^\^/ { print >>xtra; next; }
445 /^[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]+ refs\/(stash|tgstash)(\/|$)/ {
446 peeling = 1
447 print >>xtra
448 next
450 { peeling = 0; print; }
451 ' >repack/packed-refs.new
452 _xtralines="$(( $(LC_ALL=C wc -l <repack/packed-refs.extra) + 0 ))"
453 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs.new) + 0 ))"
454 if [ "$(( $_newlines + $_xtralines ))" -ne "$_lines" ]; then
455 echo >&2 "[$proj] error: make_repack_dir failed packed-refs.extra line count sanity check"
456 exit 1
458 mv -f repack/packed-refs.new repack/packed-refs.orig
459 _lines="$_newlines"
461 # Note: Git v1.5.0 introduced the "# pack-refs with:" header line for the packed-refs file
462 sed '/^# pack-refs/d; s, refs/, refs/!/,' <repack/packed-refs.orig >repack/packed-refs
463 nohead=
464 headref="$(git rev-parse --verify --quiet HEAD)" || :
465 if [ -n "$headref" ]; then
466 echo "$headref refs/!=/HEAD" >>repack/packed-refs
467 echo "$headref refs/heads/!" >>repack/packed-refs
468 nohead='\, refs/heads/!$,d; '
469 _lines=$(( $_lines + 2 ))
471 if [ $(( $(LC_ALL=C wc -l <repack/packed-refs) + 1 )) -ne "$_lines" ]; then
472 echo >&2 "[$proj] error: make_repack_dir failed packed-refs initial line count sanity check"
473 exit 1
475 sed -n "$nohead"'\, refs/heads/,p; \, refs/notes/,p; \, refs/remotes/,p' <repack/packed-refs.orig >>repack/packed-refs
476 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs) ))"
477 if [ $(( $_newlines + 1 )) -lt "$_lines" ]; then
478 echo >&2 "[$proj] error: make_repack_dir failed packed-refs extra line count sanity check"
479 exit 1
481 _lines="$_newlines"
482 optref="$(git rev-list -n 1 --all 2>/dev/null)" || :
483 if [ -n "$optref" ]; then
484 echo "$optref refs/tags/!" >>repack/packed-refs
485 _lines=$(( $_lines + 1 ))
486 echo "$optref" >repack/HEAD
487 else
488 cat HEAD >repack/HEAD
490 if [ $(LC_ALL=C wc -l <repack/packed-refs) -ne "$_lines" ]; then
491 echo >&2 "[$proj] error: make_repack_dir failed packed-refs line count sanity check"
492 exit 1
496 # Remove any crud that's been left behind by interrupted operations
497 # that did not clean up after themselves
498 remove_crud() {
499 # Remove any existing FETCH_HEAD
500 # There can only be a FETCH_HEAD if we've been fetching, not if we've been
501 # receiving pushes (those never create a FETCH_HEAD).
502 # And if we're fetching because we're a mirror, we know we're not fetching right
503 # now since jobd.pl never runs a project's fetch simultaneously with its gc.
504 # Therefore any existing FETCH_HEAD is junk. And it may be many megabytes if
505 # there were a lot of refs.
506 rm -f FETCH_HEAD
508 # Remove any stale ref locks
509 clear_stale_ref_locks
511 # remove any existing pack_is_complete_test or repack subdirectories
512 # If either exists when this function is called it's crud
513 rm -rf pack_is_complete_test repack objects/pack/repack
515 # Remove any stale pack remnants that are more than an hour old.
516 # Stale pack fragments are defined as any pack-<sha1>.ext where .ext is NOT
517 # .pack AND the corresponding .pack DOES NOT exist. A bunch of stale
518 # pack-<sha1>.idx files without their corresponding .pack files are worthless
519 # and just waste space. Normally there shouldn't be any remnants but actually
520 # this can happen when things are interrupted at just the wrong time.
521 # Note that the objects/pack directory is created by git init and should
522 # always exist.
523 find -L objects/pack -maxdepth 1 -type f -mmin +60 -name "pack-$octet20*.?*" -print |
524 LC_ALL=C sed -e 's/^objects\/pack\/pack-//; s/\..*$//' | LC_ALL=C sort -u |
525 while read packsha; do
526 ! [ -e "objects/pack/pack-$packsha.pack" ] || continue
527 rm -f "objects/pack/pack-$packsha".?*
528 done
530 # Remove any stale tmp reflogs files that are more than one hour old.
531 # Since they are created only while the pre-receive hook is running and
532 # all it does is process a bunch of refs passed to it on standard input
533 # it's inconceivable that it would ever take as much as an hour to run.
534 if [ -d reflogs ]; then
535 find -L reflogs -maxdepth 1 -type f -mmin +60 -name "tmp_*" -exec rm -f '{}' + || :
538 # Remove any stale object tmp_obj_* files that are more than 3 hours old.
539 # Really these files should only exist very briefly so there shouldn't be any
540 # but things happen that can end up leaving them behind.
541 find -L objects/$octet -maxdepth 1 -type f -mmin +180 -name "tmp_obj_?*" -exec rm -f '{}' + 2>/dev/null || :
543 # Remove any stale pack .keep files that are more than 12 hours old.
544 # We don't do anything to create any permanent pack .keep files, so they must
545 # be remnants from some failed push or something. Removing the .keep will
546 # allow the pack to be properly repacked.
547 find -L objects/pack -maxdepth 1 -type f -mmin +720 -name "pack-$octet20*.keep" -exec rm -f '{}' + || :
549 # Remove any stale tmp_pack_*, tmp_idx_*, tmp_bitmap_*, packtmp-* or .tmp-*-pack* files
550 # that are more than 12 hours old.
551 find -L objects/pack -maxdepth 1 -type f -mmin +720 \( \
552 -name "tmp_pack_?*" -o -name "tmp_idx_?*" -o -name "tmp_bitmap_?*" -o \
553 -name "packtmp-?*" -o -name ".tmp-?*-pack*" \
554 \) -exec rm -f '{}' + || :
556 # Remove any stale incoming-* object quarantine directories that are
557 # more than 12 hours old. These are new with Git >= 2.11.0.
558 # The update script uses its own incoming-* quarantine directories as well.
559 find -L . objects -maxdepth 1 -type d -name 'incoming-?*' -mmin +720 \
560 -exec rm -rf '{}' + || :
562 # Remove any stale shallow_* files that are more than 12 hours old.
563 # These can be left behind by Git >= 1.8.4.2 and < 2.0.0 when a client
564 # requests a shallow clone. Also discard stale .refs-temp* and
565 # .refs-new* files at the same time.
566 find -L . -maxdepth 1 -type f -mmin +720 \( \
567 -name "shallow_?*" -o -name ".refs-temp*" -o -name ".refs-new*" \
568 \) -exec rm -f '{}' + || :
570 # Remove any stale cmbnpcks-* dirs that are more than 12 hours old.
571 # These can be left behind by abnormal exits (e.g. power failure).
572 find -L . -maxdepth 1 -type d -mmin +720 -name "cmbnpcks-?*" \
573 -exec rm -rf '{}' + || :
575 # Remove any stale *.temp files in the objects area that are more than 12 hours old.
576 # This can be stale sha1.temp, or stale *.pack.temp so we kill all stale *.temp.
577 find -L objects -type f -mmin +720 -name "*.temp" -exec rm -f '{}' + || :
579 # Remove any stale *.lock files in the htmlcache area that might have been left
580 # behind after an abnormal exit during an attempt to update a cached file and
581 # are more than 1 hour old.
582 ! [ -d htmlcache ] || find -L htmlcache -type f -mmin +60 -name "*.lock" -exec rm -f '{}' + || :
584 # Remove any stale git-svn temp files that are more than 12 hours old.
585 # The git-svn process creates temp files with random 10 character names
586 # in the root of $GIT_DIR. Unfortunately they do not have a recognizable
587 # prefix, so we just have to kill any files with a 10-character name. We
588 # do this only for git-svn mirrors. All characters are chosen from
589 # [A-Za-z0-9_] so we can at least check that and fortunately the only
590 # collision is 'FETCH_HEAD' but that shouldn't matter.
591 # There may also be temp files with a Git_ prefix as well.
592 if [ -n "$svn_mirror" ]; then
593 _randchar='[A-Za-z0-9_]'
594 _randchar2="$_randchar$_randchar"
595 _randchar4="$_randchar2$_randchar2"
596 _randchar10="$_randchar4$_randchar4$_randchar2"
597 find -L . -maxdepth 1 -type f -mmin +720 -name "$_randchar10" -exec rm -f '{}' + || :
598 find -L . -maxdepth 1 -type f -mmin +720 -name "Git_*" -exec rm -f '{}' + || :
601 # Remove any stale fast_import_crash_<pid> files that are more than 3 days old.
602 if [ -n "$gfi_mirror" ]; then
603 find -L . -maxdepth 1 -type f -mmin +4320 -name "fast_import_crash_?*" -exec rm -f '{}' + || :
606 # Remove any stale core or *.core or core.* files that are more than 3 days old.
607 find -L . -maxdepth 1 -type f -mmin +4320 \( -name "core" -o -name "*.core" -o -name "core.*" \) \
608 -exec rm -f '{}' + || :
612 ## Garbage Collection Types
614 ## There are two kinds of possible garbage collection (gc) operations:
616 ## 1. A normal, full gc
617 ## 2. A "mini" gc
619 ## If the full garbage collection interval has expired (or gc has never been
620 ## run), then a normal, full gc will take place. Otherwise, a "mini" gc will
621 ## take place if the file .needsgc exists.
623 ## A "mini" gc is similar to "git gc --auto" in that it may not end up actually
624 ## doing anything unless the right conditions are present so it's not a burden
625 ## to run it often. If the file .needsgc exists, a "mini" gc will occur at
626 ## the next opportunity.
628 ## See the docs/technical/gc.txt and docs/technical/gc-mini.txt files for more
629 ## of the gory details of how garbage collection is performed.
631 ## Note, however, that the .nogc file suppresses ALL gc activity (normal or mini).
634 proj="${1%.git}"
635 shift
636 cd "$cfg_reporoot/$proj.git"
637 [ -d objects/pack ] || { rm -f gfi-packs; mkdir -p objects/pack; }
638 mirror_url="$(get_mirror_url)" || :
639 svn_mirror=
640 ! is_svn_mirror_url "$mirror_url" || svn_mirror=1
641 gfi_mirror=
642 if [ -f gfi-packs ] && [ -s gfi-packs ] && is_gfi_mirror_url "$mirror_url"; then
643 gfi_mirror=1
646 # If git config --bool --get girocco.redelta is explicitly false then automatic
647 # redelta when there are less than $var_redelta_threshold objects will be suppressed.
648 # On the other hand, if git config --get girocco.redelta is "always" then, on a full
649 # gc only, for the final repack, deltas will always be recomputed.
650 # This can be set on a per-project basis to avoid unusual pathological gc behavior.
651 # Setting this will hurt efficiency of the affected repository.
652 # Note that fast-import packs ALWAYS get new deltas regardless of this setting.
653 noreusedeltaopt="--no-reuse-delta"
654 [ "$(git config --bool --get girocco.redelta 2>/dev/null || :)" != "false" ] || noreusedeltaopt=
655 alwaysredelta=
656 [ "$(git config --get girocco.redelta 2>/dev/null || :)" != "always" ] || alwaysredelta=1
658 # Extract any -f or -F or --no-reuse-object or --no-reuse-delta options
659 # to be compatible with the old and new gc.sh versions and avoid ugly argument
660 # duplication in process lists at the same time
661 # Any options found will override the "girocco.redelta" setting
662 recompress=
663 idx=$#
664 while [ $idx -gt 0 ]; do
665 idx=$(( $idx - 1 ))
666 opt="$1"
667 shift
668 case "$opt" in
669 -f|--no-reuse-delta)
670 alwaysredelta=1
671 continue
673 -F|--no-reuse-object)
674 alwaysredelta=1
675 recompress=1
676 continue
678 -?*)
681 printf >&2 '%s\n' "bad non-option argument: $opt"
682 echo >&2 "(Did you perhaps intend to use a --xxx=yyy form?)"
683 exit 1
684 esac
685 [ -z "$opt" ] || set -- "$@" "$opt"
686 done
687 if [ -n "$alwaysredelta" ]; then
688 noreusedeltaopt="--no-reuse-delta"
689 [ -z "$recompress" ] || noreusedeltaopt="--no-reuse-object"
692 trap 'e=$?; rm -f .gc_in_progress; if [ $e != 0 ]; then echo "gc failed dir: $PWD" >&2; fi' EXIT
693 trap 'exit 130' INT
694 trap 'exit 143' TERM
696 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
697 datefmt='+%a, %d %b %Y %T %z'
699 isminigc=
700 if [ "${force_gc:-0}" = "0" ] && check_interval lastgc $cfg_min_gc_interval; then
701 if [ -e .needsgc ]; then
702 isminigc=1
703 else
704 progress "= [$proj] garbage check skip (last at $(config_get lastgc))"
705 exit 0
708 if [ -e .nogc ]; then
709 progress "x [$proj] garbage check disabled"
710 exit 0
712 if ! [ -e .nofetch ] && [ -e .clone_in_progress ] && ! [ -e .clone_failed ]; then
713 progress "x [$proj] garbage check disabled (clone in progress)"
714 exit 0
716 if [ -z "$isminigc" ] && [ -e .delaygc ] && [ -e .needsgc ]; then
717 # Eligible for a full gc but .delaygc is set so it would be skipped
718 # However .needsgc is also set so transform it into a mini instead
719 isminigc=1
720 progress "~ [$proj] garbage check delayed but checking mini because .needsgc"
723 if [ -n "$isminigc" ]; then
724 # Perform a "mini" gc
725 # Note that .delaygc is ignored here as that's only intended for full gc
726 lock_gc
727 rm -f .allowgc .needsgc
728 rm -f objects/pack/pack-*_[rful].keep
729 remove_crud
730 coalesce_reflogs
731 prune_reflogs
732 compact_reflogs
733 maintain_auto_gc_hack
734 generate_auto_gc_update
735 miniactive=
736 if [ -f .needspack ]; then
737 miniactive=1
738 progress "+ [$proj] mini garbage check ($(date))"
739 make_needs_pack
741 if [ -z "$cfg_delay_gfi_redelta" ] && [ -n "$gfi_mirror" ]; then
742 # $Girocco::Config::delay_gfi_redelta is false, force redeltification now
743 if [ -z "$miniactive" ]; then
744 miniactive=1
745 progress "+ [$proj] mini garbage check ($(date))"
747 repack_gfi_packs
749 if lotsa_loose_objects; then
750 if [ -z "$miniactive" ]; then
751 miniactive=1
752 progress "+ [$proj] mini garbage check ($(date))"
754 pack_loose_objects
756 # If there aren't at least 10 non-keep, non-bitmap, non-bndl packs then
757 # don't actually process them yet
758 lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl --quiet"
759 packcnt="$(list_packs --count $lpo objects/pack)" || :
760 if [ "${packcnt:-0}" -ge 10 ]; then
761 if [ -z "$miniactive" ]; then
762 miniactive=1
763 progress "+ [$proj] mini garbage check ($(date))"
765 # if we have at least 10 packs go ahead and pack all refs now too
766 git pack-refs --all --prune
767 if [ -n "$gfi_mirror" ]; then
768 repack_gfi_packs
769 packcnt="$(list_packs --count $lpo objects/pack)" || :
771 # if repack_gfi_packs dropped the pack count to < 10 don't combine
772 if [ "${packcnt:-0}" -ge 10 ]; then
773 combine_small_packs
774 combine_small_loose_packs
775 packcnt="$(list_packs --count $lpo objects/pack)" || :
777 # if we still have more than 10 packs trigger a full gc
778 if [ "${packcnt:-0}" -ge 10 ]; then
779 # We shouldn't be in a .delaygc state at this point, but if
780 # we are then nuke it because we really need a full gc now
781 rm -f .delaygc
782 git config --unset gitweb.lastgc || :
783 rm -f "$lockf"
784 git update-server-info # just in case
785 progress "- [$proj] mini garbage check triggering full gc too many packs ($(date))"
786 exit 0
789 rm -f "$lockf"
790 if [ -n "$miniactive" ]; then
791 git update-server-info
792 progress "- [$proj] mini garbage check ($(date))"
793 else
794 progress "= [$proj] mini garbage check nothing but crud removal to do ($(date))"
796 exit 0
799 # Avoid unnecessary garbage collections:
800 # 1. If lastreceive is set and is older than lastgc
801 # -AND-
802 # 2. We are not a fork (is_empty_alternates_file) -OR- lastparentgc is older than lastgc
804 # If lastgc is NOT set or lastreceive is NOT set we MUST run gc
805 # If we are a fork and lastparentgc is NOT set we MUST run gc
807 # If the repo is dirty after removing any crud we MUST run gc
809 gcstart="$(date "$datefmt")"
810 skipgc=
811 isfork=
812 is_empty_alternates_file objects/info/alternates || isfork=1
813 lastparentgcsecs=
814 [ -z "$isfork" ] || lastparentgcsecs="$(config_get_date_seconds lastparentgc)" || :
815 lastreceivesecs=
816 if lastreceivesecs="$(config_get_date_seconds lastreceive)" &&
817 [ "${force_gc:-0}" = "0" ] &&
818 lastgcsecs="$(config_get_date_seconds lastgc)" &&
819 [ $lastreceivesecs -lt $lastgcsecs ]; then
820 # We've run gc since we last received, so maybe we can skip,
821 # check if not fork or fork and lastparentgc < lastgc
822 if [ -n "$isfork" ]; then
823 if [ -n "$lastparentgcsecs" ] &&
824 [ $lastparentgcsecs -lt $lastgcsecs ]; then
825 # We've run gc since our parent ran gc so we can skip
826 skipgc=1
828 else
829 # We don't have any alternates (we're not a forK) so we can skip
830 skipgc=1
834 # Now check the simple signatures if $skipgc and decline to skip if they do not match
836 if [ -n "$skipgc" ]; then
837 # while we cannot actually compute the current "repack" "signature"
838 # hash yet, if there is no previous sig => must run gc
839 rpksig="$(config_get girocco.gcsig.repack)" || :
840 [ -n "$rpksig" ] || skipgc=
842 if [ -n "$skipgc" ]; then
843 # make sure the "refs" "signature" hash exists before doing anything expensive
844 # no previous "refs" "signagure" => must run gc
845 rhash="$(config_get girocco.gcsig.refs)" || :
846 [ -n "$rhash" ] || skipgc=
848 if [ -n "$skipgc" ]; then
849 # check the "packs" "signature" first, no previous sig => must run gc
850 phash="$(config_get girocco.gcsig.packs)" || :
851 [ -n "$phash" ] || skipgc=
852 if [ -n "$skipgc" ]; then
853 # a previous packs sig is available, check for a match
854 _chksig="$(list_packs -C objects/pack --exclude-no-idx --quiet . |
855 LC_ALL=C sort | sig_hash_stdin)" || :
856 [ "$phash" = "$_chksig" ] || skipgc=
859 if [ -n "$skipgc" ]; then
860 # check the refs signature second
861 # a previous refs sig is available, check for a match
862 v_compute_refs_sighash _chksig
863 [ "$rhash" = "$_chksig" ] || skipgc=
866 # Prevent any other simultaneous gc operations
867 lock_gc
869 # At this point, if .allowgc or .gc_failed exists, it's now crud to be removed
870 rm -f .allowgc .gc_failed
872 # Always get rid of crud
873 remove_crud
875 # Ideally we would do this in post-receive, but that would mean duplicating the
876 # logic so it's available in the chroot jail and that's highly undesirable
877 # Instead, since the first gc will be triggered immediately following the first
878 # push, we do the check here as it's quick and harmless if HEAD is already valid
879 check_and_set_head || :
881 # Always perform reflogs maintenance
882 coalesce_reflogs
883 prune_reflogs
884 compact_reflogs
886 # Always maintain auto gc hack
887 maintain_auto_gc_hack
888 generate_auto_gc_update
890 # Run 'git svn gc' now for svn mirrors
891 if [ -n "$svn_mirror" ]; then
892 git svn gc || :
895 # Skip the actual gc if .delaygc is set
896 if [ -e .delaygc ]; then
897 progress "x [$proj] garbage check delayed (except for crud removal)"
898 rm -f "$lockf"
899 exit 0
902 # Do not skip gc if the repo is dirty
903 [ -z "$skipgc" ] || ! is_dirty || skipgc=
905 # It's safe to do this part before checking the "repack" "signature" hash because
906 # this section won't do anything unless lastparentgc and/or lastreceive is unset
907 # in which case we never skip gc anyway
908 bumptime=
909 if [ -n "$isfork" ] && [ -z "$lastparentgcsecs" ]; then
910 # set lastparentgc and then update gcstart to be at least 1 second later
911 config_set lastparentgc "$gcstart"
912 bumptime=1
914 if [ -z "$lastreceivesecs" ]; then
915 # set lastreceive and then update gcstart to be at least 1 second later
916 config_set lastreceive "$gcstart"
917 bumptime=1
919 if [ -n "$bumptime" ]; then
920 sleep 1
921 gcstart="$(date "$datefmt")"
925 ## Safe Pruning In Forks
927 ## We are about to perform garbage collection. We do NOT use the "git gc" or
928 ## the "git repack" commands directly as they do not provide enough control over
929 ## the fine details. However, we DO maintain a "gc.pid" file during our garbage
930 ## collection so that a simultaneous "git gc" by an administrator will be
931 ## blocked (and similarly we refuse to start garbage collection if we cannot
932 ## create the "gc.pid" file).
934 ## When we say "gc" in the below description we are referring to our "gc.sh"
935 ## script, NOT the "git gc" command.
937 ## If the project we are running garbage collection (gc) on has any forks we
938 ## must be careful not to remove any objects that while no longer referenced by
939 ## this project (the parent) are still referenced by one or more forks (the
940 ## children) otherwise the children will become corrupt and we can't abide
941 ## corrupt children.
943 ## One way to accomplish this is to simply hard-link all currently existing
944 ## loose objects and packs in the parent into all the children that refer to the
945 ## parent (via a line in their objects/info/alternates file) before beginning
946 ## the gc operation and then relying on a subsequent gc in the child to clean up
947 ## any excess objects/packs. We used to use this strategy but it's very
948 ## inefficient because:
950 ## 1. The disk space used by the old pack(s)/object(s) will not be reclaimed
951 ## until all children (and their children, if any) run gc by which time
952 ## it's quite possible the topmost parent will have run gc again and
953 ## hard-linked yet another old pack down to its children (not to mention
954 ## loose objects).
956 ## 2. When using the "-A" option with "git repack", any new objects in the
957 ## parent that are not referenced by children will continually get
958 ## exploded out of the hard-linked pack in the children whenever the
959 ## children run gc.
961 ## 3. To avoid suboptimal and/or unnecessarily many packs being hard-linked
962 ## into child forks, we must run the "mini" gc maintenance before we
963 ## perform the hard-linking into the children which provides yet another
964 ## source of inefficiency.
966 ## While we were still using the "-A" option to "git repack" (that was not
967 ## always the case) to guarantee we can access old ref values for long enough
968 ## to send out a meaningful mail.sh notification, another, more efficient,
969 ## option became available to prevent corruption of child forks that continue
970 ## to refer to objects that are no longer reachable from any ref in the parent.
972 ## The only things that need be copied (or hard-linked) into the child fork(s)
973 ## are those objects that have become unreachable from any ref in the parent.
975 ## When we were using the "git repack -A -d" + "git prune --expire=1.day.ago"
976 ## technique, the only objects that could ever be removed were loose objects
977 ## that "git prune" determined were expired. In that case, loose objects were
978 ## all that need be hard-linked down to child forks in order to avoid
979 ## corruption of any child fork(s).
981 ## The "git repack -A -d" + "git prune --expire=1.day.ago" + hard-linking loose
982 ## objects to child forks technique remains fundamentally sound from the
983 ## perspective of supporting simultaneous gc and push and keeping newly
984 ## unreachable objects around long enough to be sure we can send out meaningful
985 ## ref change notifications and never corrupting any child forks and never
986 ## persisting the lifetime of large old packs containing mostly duplicate or
987 ## unreachable objects as gc percolates through a project's entire fork tree.
989 ## However, that technique suffers from one potential prodigious pitfall.
991 ## Unreachable objects come flying out of their packs to splatter all over the
992 ## objects subdirectories possibly creating a huge, inefficient mess.
994 ## Often this is not an issue. Even with a lot of rebasing going on, usually
995 ## the only objects that will splatter are some commits, trees and the odd blob
996 ## here and there. Not enough to be overly concerned about.
998 ## However, for the reppository that frequently experiences a lot of non-fast-
999 ## forward updates and/or outright ref deletion, the number of objects suddenly
1000 ## popping out of their packs at "git repack -A -d" time can be overwhelming.
1002 ## To avoid this issue we now use a four phase pack creation strategy.
1003 ## This will result in creation of up to four packs (instead of at most one).
1005 ## I. A complete pack (with bitmaps if appropriate) gets created including
1006 ## only "reachable" objects from all refs/... refs plus HEAD. This will
1007 ## also serve as the virtual bundle for the repository.
1009 ## II. A pack of recently-became-unreachable objects and friends is created.
1010 ## (The "friends" are ref logs, linked working tree HEADs and indicies.)
1011 ## Because both the pre-receive and update.sh script record all ref
1012 ## changes we can easily choose the cut off point for "recently".
1013 ## It is only the fact we maintain those logs in the reflogs subdirectory
1014 ## that allows this step to be possible.
1016 ## III. If the repository has any forks with a non-zero length alternates file,
1017 ## yet another pack of "--keep-unreachable" objects is generated that will
1018 ## not actually be kept in the parent, but hard-linked into all the forks.
1020 ## IV. Finally, after running "git prune-packed", any remaining loose objects
1021 ## are migrated into a pack of their own.
1023 ## We then remove any non-.keep packs that existed before we started the
1024 ## process being careful to keep any same-pack pushes for the "Push Pack Redux"
1025 ## race condition (see docs/technical/gc.txt).
1027 ## By using "git pack-objects" directly we are able to accomplish this with
1028 ## very little additional effort.
1030 ## The packs produced by (III) are treated almost like ".keep" packs by child
1031 ## forks in that the objects in them are never repacked into any other
1032 ## "--keep-unreachable" packs (but they can migrate into phase I or II packs)
1033 ## and those phase III packs are then hard-linked into any grandchild forks.
1035 ## This avoids the space explosion that could occur if each fork level ended
1036 ## up duplicating the "--keep-unreachable" pack space by repacking those
1037 ## objects (essentially breaking the hard-link to the single copy of those
1038 ## objects).
1040 ## While it is true that each level of forks could potentially add yet another
1041 ## phase III pack to be hard-linked down to its children, such packs will only
1042 ## include unreachable objects not already in any phase III packs that were
1043 ## received from the parent.
1045 ## The space for the phase III packs will not be reclaimed until the gc
1046 ## finishes percolating through the entire "fork tree" of a project.
1048 ## This is not much different than the "git repack -A -d" situation where
1049 ## all the loose objects are hard-linked down into child forks. In that
1050 ## case forks that actually need any of those objects could gradually reduce
1051 ## the number of objects hard-linked into deeper fork levels.
1053 ## The difference with a phase III "--keep-unreachable" pack is that there
1054 ## cannot be any gradual reduction like that since it would require repacking
1055 ## the pack and breaking the hard-link thereby increasing storage space. The
1056 ## storage will instead always be reclaimed all at once when all of the
1057 ## projects in the "fork tree" complete their gc.
1059 ## However, the belief is that the huge space win by having all the
1060 ## unreachable objects packed up together far eclipses (when many objects are
1061 ## involved, the single-pack version can end up using 1/20th or less of the
1062 ## disk space compared to having them all as loose objects) any brief minor
1063 ## space savings that might occur under the "git repack -A -d" loose object
1064 ## system prior to the gc collection completing for all the projects in the
1065 ## "fork tree".
1069 ## utility functions
1072 make_packs_ugw() {
1073 find -L "$1" -maxdepth 1 -type f ! -perm -ug+w \
1074 -name "pack-$octet20*.pack" -exec chmod ug+w '{}' + || :
1075 } 2>/dev/null
1077 get_index_tree() {
1078 if [ -s "$1" ]; then
1079 GIT_INDEX_FILE="$1"
1080 export GIT_INDEX_FILE
1081 git write-tree 2>/dev/null || :
1082 unset GIT_INDEX_FILE
1086 get_detached_head() {
1087 if [ -s "$1" ] && read -r _head <"$1" 2>/dev/null; then
1088 case "$_head" in $octet20*)
1089 echo "$_head"
1090 esac
1094 # single argument must be a top-level GIT_DIR
1095 # output will be (one per line, zero or more lines) full hash
1096 # values (i.e. 40 or more hex digits) from possible detached head
1097 # "single level" refs (e.g. "FETCH_HEAD" "MERGE_HEAD" etc.) from
1098 # files in the specified directory that have a "suitable" name and
1099 # have a length >= 40 and <= 1000 where EVERY line in a file MUST
1100 # match a 40 digit (or longer) hex string or that file will be ignored.
1101 # In a nod to Git each line first has any tab and anything following truncated.
1102 # NO sorting NOR "uniq"ing NOR "--batch-check"ing is performed on the output.
1103 # Also note that "HEAD" is NOT EXCLUDED and if detached will be output!
1104 get_detached_friends() {
1105 if [ -n "$1" ] && [ -d "$1" ]; then
1106 LC_ALL=C find -H "$1" -maxdepth 1 -name '[A-Za-z]*[A-Za-z0-9]' \
1107 -type f -size +39c -size -1001c -exec awk '
1108 BEGIN {exit}
1109 function process(fn, fnt, hashes, hcnt, fl, hi) {
1110 fnt = fn; sub(/^.*\//, "", fnt)
1111 if (length(fnt) > 31 || fnt !~ /^[A-Za-z][A-Za-z0-9_-]*[A-Za-z0-9]$/) return;
1112 hcnt = 0;
1113 while (getline fl < fn) {
1114 sub(/\t.*$/, "", fl)
1115 if (length(fl) < 40 || fl !~ /^[0-9a-fA-F][0-9a-fA-F]*$/) {hcnt = 0; break;}
1116 hashes[++hcnt] = fl;
1118 close(fn)
1119 for (hi=1;hi<=hcnt;++hi) print tolower(hashes[hi]);
1121 END {for (idx=1;idx<ARGC;++idx) process(ARGV[idx])}
1122 ' '{}' '+' 2>/dev/null || :
1126 # get_worktrees_friends
1127 # single argument is a (possibly relative) path to a "worktrees" subdir
1128 # if omitted it defaults to "worktrees"
1129 # any "friends" found in there are output to stdout
1130 get_worktrees_friends() {
1131 if [ -d "${1:-worktrees}" ]; then
1132 find -L "${1:-worktrees}" -mindepth 2 -maxdepth 2 -name HEAD -type f -print |
1133 while read -r _lwth; do
1134 get_detached_head "$_lwth"
1135 get_detached_friends "${_lwth%HEAD}"
1136 get_index_tree "${_lwth%HEAD}index"
1137 done
1141 # compute_extra_reachables
1142 # create lines suitable for a packed-refs file mentioning all the
1143 # other refs we might like to keep.
1144 # the current directory MUST be set to the repository's --git-dir
1145 # the following are included:
1146 # * refs mentioned in repack/packed-refs.extra (if it exists)
1147 # * refs mentioned in reflogs/... files
1148 # * tree(s) created from index file(s)
1149 # * detached linked working tree heads
1150 # Resulting objects are tested for existence and uniqified then output
1151 # one per line under a refs/z* namespace
1152 compute_extra_reachables() {
1154 if [ -s repack/packed-refs.extra ]; then
1155 LC_ALL=C sed <repack/packed-refs.extra -n \
1156 -e 's/^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p' \
1157 -e 's/^\^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p'
1159 digits8='[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]'
1160 find -L reflogs -mindepth 1 -maxdepth 1 -type f -name "$digits8*" -exec gzip -c -d -f '{}' + |
1161 LC_ALL=C awk '{print $2; print $3}'
1162 get_detached_friends .
1163 ! [ -f index ] || get_index_tree index
1164 get_worktrees_friends
1166 is_git_dir private &&
1167 [ "$(cd objects && pwd -P)" = "$(cd private/objects && pwd -P)" ] &&
1168 [ "$(cd refs && pwd -P)" != "$(cd private/refs && pwd -P)" ]
1169 then
1170 git --git-dir=private show-ref --head --hash 2>/dev/null || :
1171 get_detached_friends private
1172 ! [ -f private/index ] || get_index_tree private/index
1173 get_worktrees_friends private/worktrees
1175 } | LC_ALL=C sort -u |
1176 git cat-file ${var_have_git_260:+--buffer} --batch-check"${var_have_git_185:+=%(objectname)}" |
1177 LC_ALL=C awk '!/missing/ {num++; print $1 " " "refs/" substr("zzzzzzzzzzzz", 1, length(num)) "/" num}'
1180 # cat_all_ref_logs
1181 # the current directory MUST be set to the repository's --git-dir
1182 # first the arguments (which must reference readable files) are cat'd if any
1183 # then the path names of all ref log files are sorted and cat'd in that order
1184 # included in output:
1185 # * the contents of the pathnames given as arguments (if any) in order
1186 # * any existing files in the logs subdirectory and any existing worktree HEAD logs
1187 # but always in sorted filename order
1188 # obviously any missing directories are silently skipped
1189 cat_all_ref_logs() {
1190 [ $# -le 0 ] || LC_ALL=C cat -- "$@"
1192 ! [ -d logs ] || find -L logs -name '.*' -prune -o -name '*.' -prune -o -type f -size +0c -print
1193 if [ -d worktrees ]; then
1194 find -L worktrees -mindepth 2 -maxdepth 2 -name HEAD -type f -print |
1195 while read -r _lwth; do
1197 [ -d "${_lwth%HEAD}logs" ] &&
1198 [ -f "${_lwth%HEAD}logs/HEAD" ]
1199 then
1200 printf '%s\n' "${_lwth%HEAD}logs/HEAD"
1202 done
1204 } | LC_ALL=C sort | LC_ALL=C sed 's/[^A-Za-z0-9._/-]/\\&/g' | xargs env LC_ALL=C cat --
1208 ## main gc logic
1211 # Everything else is more efficient if we do this first
1212 # The "--prune" option is the default since v1.5.0 but it serves as "documentation" here
1213 git pack-refs --all --prune
1214 [ -e packed-refs ] || >>packed-refs # should never happen...
1216 # We didn't used to do anything about rerere or worktrees but we're
1217 # trying to make nice with linked working trees these days :)
1218 # Maybe even non-bare repositories too, but *shush* about those ;)
1220 # If we have a worktrees subdir and are running Git >= 2.5.0, prune worktrees
1221 # By doing this first we may save some work if any worktrees are pruned
1222 # Git will remove the worktrees subdir entirely when the last worktree is pruned
1223 if [ -n "$var_have_git_250" ] && [ -d worktrees ]; then
1224 # The value "3.months.ago" is hard-coded into gc.c rather than
1225 # having the default be in worktree.c so we must provide it if
1226 # we get nothing out of the gc.worktreePruneExpire config item
1227 # Prior to Git v2.6.0 the config item was gc.pruneworktreesexpire
1228 # however we just always use the newer name no matter what Git version
1229 expiry="$(git config --get gc.worktreePruneExpire 2>/dev/null)" || :
1230 eval git worktree prune --expire '"${expiry:-3.months.ago}"' "${quiet:+>/dev/null 2>&1}" || :
1233 # If we have a logs directory or a worktrees directory expire the ref logs now
1234 # Note that Git itself does not use either --rewrite or --updateref, so neither do we
1235 ! [ -d logs ] && ! [ -d worktrees ] || eval git reflog expire --all "${quiet:+>/dev/null 2>&1}" || :
1237 # git rerere does it right and handles its own default/config'd expiration values
1238 ! [ -d rr-cache ] || eval git rerere gc "${quiet:+>/dev/null 2>&1}" || :
1240 make_repack_dir
1242 # if we are in a possible $skipgc situation, compute and check the final
1243 # signature hash and possibly exit without actually doing anything more
1244 # if we get this far and $skipgc is true then $rpksig must be non-empty
1245 if [ -n "$skipgc" ]; then
1246 # compute the current value of the "repack" "signature" hash
1247 # it wasn't possible to do this until `make_repack_dir` was run
1248 _chksig="$({
1249 cat repack/packed-refs
1250 compute_extra_reachables
1251 cat_all_ref_logs
1252 } | sig_hash_stdin)" || :
1253 [ "$rpksig" = "$_chksig" ] || skipgc=
1256 if [ -n "$skipgc" ]; then
1257 # remove no longer needed repack and objects/pack/repack dirs and contents
1258 # while not free to create them, it's cheaper to create and destroy
1259 # them than to do an actual full gc on anything but a tiny project
1260 rm -rf repack objects/pack/repack
1261 progress "= [$proj] garbage check nothing but crud removal to do ($(date))"
1262 config_set lastgc "$gcstart"
1263 rm -f "$lockf"
1264 exit 0
1267 progress "+ [$proj] garbage check ($(date))"
1269 newdeltas=
1270 [ -z "$alwaysredelta" ] || newdeltas="$noreusedeltaopt"
1271 if [ -z "$newdeltas" ] && [ -n "$gfi_mirror" ]; then
1272 if [ $(list_packs --exclude-no-idx --count objects/pack) -le \
1273 $(list_packs --exclude-no-idx --count --quiet --only gfi-packs) ]; then
1274 # Don't bother with repack_gfi_packs since everything's being repacked
1275 newdeltas="--no-reuse-delta"
1278 if [ -z "$newdeltas" ] && [ -n "$noreusedeltaopt" ] &&
1279 [ $(list_packs --all --exclude-no-idx --count-objects objects/pack) -le $var_redelta_threshold ]; then
1280 # There aren't enough objects to worry about so just redelta to get the best pack
1281 newdeltas="--no-reuse-delta"
1283 if [ -z "$newdeltas" ]; then
1284 # Since we're not going to recompute deltas overall, we need to do the
1285 # "mini" maintenance so that we can get more optimal deltas
1286 [ -z "$noreusedeltaopt" ] || make_needs_pack
1287 repack_gfi_packs
1288 force_single_pack_redelta=
1289 [ -n "$gfi_mirror" ] || [ -n "$svn_mirror" ] || force_single_pack_redelta=1
1290 [ -z "$noreusedeltaopt" ] || combine_small_packs $force_single_pack_redelta
1291 [ -z "$noreusedeltaopt" ] || combine_small_loose_packs $force_single_pack_redelta
1293 ! [ -e .gc_failed ] || exit 1
1294 rm -f .gc_in_progress # make sure
1295 touch .gc_in_progress # it's truly fresh
1296 rm -f bundles/* objects/pack/pack-*.bndl
1297 # These only exist for a brief time before the packs loose their _f suffix
1298 # "Push Pack Redux" does not apply to these since they were only ever present with _f
1299 rm -f objects/pack/pack-*_f.keep
1300 # This is perhaps a bit aggressive in that if we're suffering from "Push Pack Redux"
1301 # and somehow we get run again immediately after the run where "Push Pack Redux" happened
1302 # and we have garbage collection forced, there's just the barest, almost negligible,
1303 # possibility that the "Push Pack Redux" ref updates _still_ have not happened and we
1304 # should not be removing _r .keep files. None of the normal Girocco processing can
1305 # cause this. The second run of this script would have to use the force gc option
1306 # for it to even be possible in the first place. What's much more likely is that
1307 # the initial run of this script was somehow interrupted in the middle before it
1308 # could get rid of the _r .keep file itself in which case it's better to get rid of
1309 # it now to avoid keeping something around that would perturb our nice and neat gc
1310 rm -f objects/pack/pack-*_r.keep
1311 # We will add .keep files for _u and _l packs if and when we run phase III
1312 # Otherwise they need to not have any .keep files during phases I and II
1313 rm -f objects/pack/pack-*_[ul].keep
1315 # We need to make sure that any non-Girocco (barely tolerated) Git object creation
1316 # activity will be able to "freshen" the pack containing a pre-existing object
1317 # that's being written. This really should not be necessary as the pre-receive
1318 # hook should make sure this takes place for any incoming pushes.
1319 # However, do it here anyway just in case.
1320 make_packs_ugw objects/pack
1322 # This is only effective with Git v2.3.5 and later and it will only matter when
1323 # we are using one of the "internal_rev_list" modes of pack-objects
1324 # (the combine-packs.sh script never uses any of those modes)
1325 # The "git repack" and "git prune" commands always set this internally themselves
1326 # It makes no difference if there's no repository corruption
1327 GIT_REF_PARANOIA=1 && export GIT_REF_PARANOIA
1329 # All of the options we might want to use with pack-objects were supported
1330 # at some point prior to Git version v1.6.6 which is the minimum version that
1331 # Girocco now requires. Except for one (--use-bitmap-index). Several of them
1332 # are "boiler plate" options we always want to use so we bundle them up here.
1333 pkopt="--delta-base-offset --keep-true-parents --non-empty --all-progress-implied"
1334 # We want to use --include-tag, but before Git v2.10.1 it would leave out
1335 # "middle" tags (e.g. a tag of a tag of a commit would omit the tagged tag)
1336 # See http://repo.or.cz/git.git/b773ddea2cd3b08c for details
1337 # ("pack-objects: walk tag chains for --include-tag", 2016-09-07, v2.10.1)
1338 # This is not a free check as it matches all refs against refs/tags/ then
1339 # peels all the annotated tags and checks for inclusion. The situation in
1340 # which it would add a tag that was not already included by a reachability
1341 # trace that included tag starting points can only occur if a new tag gets
1342 # pushed during gc pointing to something that would have been packed anyway.
1343 # But, it could happen and, really, compared to gc as a whole it's not that
1344 # expensive to perform (provided we do not get an unconnected pack).
1345 [ -z "$var_have_git_2101" ] || pkopt="$pkopt --include-tag"
1346 pkopt="$pkopt ${quiet:---progress} $packopts"
1348 # The git pack-objects command only supports bitmaps if all objects are being
1349 # packed (the "--all" option) and the "--stdout" option is NOT being used.
1350 # Additionally, while packing, if any encountered reachable objects are
1351 # determined to be "not wanted" then no bitmap index will be written anyway.
1352 # While it is theoretically possible that a project with a non-empty alternates
1353 # file ends up packing all objects (because it does not actually use any of the
1354 # objects found in the alternates), it's very unlikely. And, in the unlikely
1355 # event that did occur, clients would see a message about only using one bitmap
1356 # because Git can only use one bitmap at a time and at least one of the
1357 # alternates is bound to have a bitmap. Therefore if we see a non-empty
1358 # alternates file, we disable writing bitmaps which avoids the warning and any
1359 # possibility of a client warning as well. Also if we are running anything
1360 # before Git v2.1.0 (the effective version for repack.writeBitmaps=true) then
1361 # we also always disable bitmap writing.
1362 wbmopt=
1363 [ -z "$var_have_git_210" ] || wbmopt="--write-bitmap-index"
1364 # More recent versions of pack-objects have optimizations when not using the
1365 # --local option. If we do not have any alternates it's a pointless option.
1366 # If we do have alternates we need to skip writing a bitmap and we cannot
1367 # have a bundle since it must contain all objects.
1368 if [ -n "$isfork" ]; then
1369 lclopt="--local"
1370 wbmopt=
1371 makebndl=
1372 else
1373 lclopt=
1374 makebndl=1
1378 ## Phase I
1381 wbmstr=
1382 [ -n "$wbmopt" ] || wbmstr=" (bitmaps disabled)"
1383 progress "~ [$proj] running primary full gc pack-objects$wbmstr ($(date))"
1385 gotforks=
1386 ! has_forks_with_alternates "$proj" || gotforks=1
1388 # To avoid "Push Pack Redux" (see docs/technical/gc.txt), after collecting the
1389 # initial preexisting non-keep pack list, we rename them so that an incoming push
1390 # pack cannot possibly experience a pack name collision. Git does not require
1391 # use of the "default" pack names, simply that the proper extensions are used.
1392 # We rename to insert an "_r" just before the extension to avoid "Push Pack Redux"
1393 # name collisions. Later on we may create an "unreachable" pack for hard-linking
1394 # down into forks and it will have an "_u" inserted just before its extension.
1395 packlist="$(list_packs -C objects/pack --all --exclude-no-idx --exclude-keep --quiet .)" || :
1396 oldpacks=
1397 for oldpack in $packlist; do
1398 oldpack="${oldpack%.pack}"
1399 [ -f "objects/pack/$oldpack.pack" ] || {
1400 echo >&2 "[$proj] unable to list old pack files"
1401 exit 1
1403 case "$oldpack" in pre-auto-gc-[12])
1404 # we never disturb pre-auto-gc-1 or pre-auto-gc-2 packs
1405 continue
1406 esac
1407 oldpackhex="${oldpack#pack-}"
1408 if [ "${oldpackhex#*[!0-9a-fA-F]}" != "$oldpackhex" ]; then
1409 # names not exclusively hexadecimal do not need renaming
1410 case "$oldpack" in
1411 pack-$octet20*_l)
1412 # _l packs are treated like still-unpacked loose objects
1413 continue;;
1414 *_f)
1415 # _f packs can only be left over from a previously interrupted gc;
1416 # they need to be renamed to _r now so they're not confused with
1417 # any freshly generated "final" packs (and we already removed
1418 # any pre-existing *_f.keep files so we're good to go)
1421 oldpacks="${oldpacks:+$oldpacks }$oldpack"
1422 continue;;
1423 esac
1425 rename_pack "objects/pack/$oldpack" "objects/pack/${oldpack%_f}_r" || {
1426 echo >&2 "[$proj] unable to rename old pack files"
1427 exit 1
1429 # If the oldpack has a .keep now it means a "Push Pack Redux" is actually
1430 # in progress at this moment and we need to .keep the renamed pack,
1431 # otherwise no "Push Pack Redux" has started yet or it has already finished.
1432 # In either case we're okay because if it's just finished then all ref
1433 # changes have already been made so we don't need a .keep and we will
1434 # see the ref changes and grab all the objects via a reachability trace.
1435 # If it hasn't started yet that's okay because we're done moving that
1436 # name so a complete pack will appear under the old name that we'll
1437 # leave alone.
1438 if [ -f "objects/pack/$oldpack.keep" ]; then
1439 echo "Push Pack Redux" >"objects/pack/${oldpack%_f}_r.keep"
1440 else
1441 oldpacks="${oldpacks:+$oldpacks }${oldpack%_f}_r"
1443 done
1445 # We wish to keep deltas from our last full pack so if we're not redeltaing
1446 # then make sure the .pack associated with the .bitmap has a newer mod time
1447 # (If there is no .bitmap then touch the pack with the most objects instead.)
1448 if [ -z "$newdeltas" ]; then
1449 bmpack="$(list_packs --exclude-no-bitmap --exclude-no-idx --max-matches 1 objects/pack)"
1450 [ -n "$bmpack" ] || bmpack="$(list_packs --exclude-no-idx --max-matches 1 --object-limit -1 --include-boundary objects/pack)"
1451 if [ -n "$bmpack" ] && [ -f "$bmpack" ] && [ -s "$bmpack" ]; then
1452 sleep 1
1453 touch -c "$bmpack" 2>/dev/null || :
1454 # We must touch .gc_in_progress here to avoid $bmpack looking
1455 # like it's been "freshened" when redundant packs are removed
1456 # It's okay if they have the same mod time, but POSIX does not
1457 # guarantee an ordering for the "touching" that occurs which is
1458 # why this must be a separate command but needs no "sleep 1"
1459 touch .gc_in_progress
1463 # Now we need to make sure that any "freshening" that takes place will actually
1464 # result in a "newer" modification time than the .gc_in_progress file now has
1465 sleep 1
1467 # We run git pack-objects from the repack subdirectory so we can force
1468 # optimized packs to be generated even for repositories that do not have any
1469 # tagged commits
1470 packs="$(git --git-dir=repack pack-objects </dev/null \
1471 $pkopt --all $newdeltas $lclopt ${wbmopt:---honor-pack-keep} "$@" repack/alt/pack/pack)"
1472 v_cnt packcnt $packs
1473 [ $packcnt -eq 1 ] || makebndl=
1476 ## Phase II
1479 progress "~ [$proj] running supplementary gc pack-objects ($(date))"
1481 # Add the "supplementary" refs
1482 compute_extra_reachables >>repack/packed-refs
1484 # Now calculate the final repack signature hash
1485 # Since we do _allow_ worktrees and we do _allow_ ref logs,
1486 # the ref logs of such must be accounted for here as well
1487 _rpksig="$(cat_all_ref_logs repack/packed-refs | sig_hash_stdin)"
1488 echo "$_rpksig" >repack/repack.sighash
1490 # Subtract the primary refs
1491 GIT_ALTERNATE_OBJECT_DIRECTORIES="$PWD/repack/alt"
1492 export GIT_ALTERNATE_OBJECT_DIRECTORIES
1494 # For this one we MUST use --local and MUST NOT use --write-bitmap-index
1495 # However, if there is a "logs" subdirectory we need to use --reflog
1496 # We do add it, just in case, if the linked working trees dir is present
1497 # We do not add --indexed-objects as that requires v2.2.0 and it's unclear
1498 # if it properly includes linked working tree index files or not. The
1499 # above compute_extra_reachables has already included all index trees (thereby
1500 # providing proper --indexed-objects support for all Git versions) making the
1501 # option completely unnecessary.
1502 rflopt=
1503 ! [ -d logs ] && ! [ -d worktrees ] || rflopt=--reflog
1504 spacks="$(git --git-dir=repack pack-objects </dev/null \
1505 $pkopt --honor-pack-keep --all $rflopt $newdeltas --local "$@" repack/alt/pack/pack)"
1508 ## Phase III
1511 # There's nothing to do for Phase III unless we have forks that refer to our
1512 # project from their alternates file
1513 hlpacks=
1514 upacks=
1515 if [ -n "$gotforks" ]; then
1517 progress "~ [$proj] running keep-unreachable gc pack-objects for forks ($(date))"
1519 # If we are a fork, any pre-existing _u packs need to have a .keep
1520 # for this phase and be added to the hlpacks list otherwise (we are
1521 # not a fork) pre-existing _u packs are anomalies to be treated like
1522 # regular non-_u packs
1523 if [ -n "$isfork" ]; then
1524 for upack in $(find -L objects/pack -mindepth 1 -maxdepth 1 -name "pack-$octet20*_[ul].pack" -print); do
1525 upack="${upack%.pack}"
1526 [ -e "$upack.keep" ] || echo "unreachable" >"$upack.keep"
1527 case "$upack" in *_l);;*)
1528 hlpacks="${hlpacks:+$hlpacks }${upack#objects/pack/pack-}"
1529 esac
1530 done
1532 # Using either --no-reuse-delta or --no-reuse-object together with the
1533 # --keep-unreachable option is a very, very, very bad idea when good
1534 # packs are the desired outcome. If newdeltas are being generated
1535 # then we pack to a temp name, and use combine-packs.sh to get a better
1536 # pack as the result to avoid making a bad --keep-unreachable pack
1537 pfx=
1538 [ -z "$newdeltas" ] || pfx="ku"
1539 upacks="$(git --git-dir=repack pack-objects </dev/null \
1540 $pkopt --honor-pack-keep --all $rflopt --keep-unreachable --local "$@" repack/alt/pack/${pfx}pack)"
1541 if [ -n "$upacks" ] && [ -n "$newdeltas" ]; then
1542 progress "~ [$proj] rebuilding keep-unreachable pack deltas"
1543 oldupacks="$upacks"
1544 upacks="$(
1545 printf "repack/alt/pack/${pfx}pack-%s.pack\n" $oldupacks |
1546 run_combine_packs --names --weak-naming --non-empty --all-progress-implied ${quiet:---progress} \
1547 $packopts $newdeltas "$@" repack/alt/pack/pack)"
1548 eval rm -f "$(printf \""repack/alt/pack/${pfx}pack-%s.*"\"" " $oldupacks)"
1550 for upack in $upacks; do
1551 rename_pack "repack/alt/pack/pack-$upack" "repack/alt/pack/pack-${upack}_u"
1552 done
1553 rm -f objects/pack/pack-*_[ul].keep
1554 [ -z "$hlpacks" ] && [ -z "$upacks" ] ||
1555 progress "~ [$proj] hard-linking keep-unreachable pack(s) into immediate child forks"
1557 # We have to update the lastparentgc time in the child forks even if they do not get any
1558 # new "unreachable packs" because they need to run gc just in case the parent now has some
1559 # objects that used to only be in the child so they can be removed from the child.
1560 # For example, a "patch" might be developed first in a fork and then later accepted into
1561 # the parent in which case the objects making up the patch in the child fork are now
1562 # redundant (since they're now in the parent as well) and need to be removed from the
1563 # child fork which can only happen if the child fork runs gc.
1564 lastparentgc="$(date "$datefmt")"
1566 # It is enough to copy objects just one level down and get_repo_list
1567 # takes a regular expression (which is automatically prefixed with '^')
1568 # so we can easily match forks exactly one level down from this project
1569 forkdir="$proj"
1570 get_repo_list "$forkdir/[^/:][^/:]*:" |
1571 while read fork; do
1572 # Ignore forks that do not exist or are symbolic links
1573 ! [ -L "$cfg_reporoot/$fork.git" ] && [ -d "$cfg_reporoot/$fork.git" ] ||
1574 continue
1575 # Or have an empty alternates file
1576 ! is_empty_alternates_file "$cfg_reporoot/$fork.git/objects/info/alternates" ||
1577 continue
1578 runupdate=
1579 # Match hlpacks in parent project if any
1580 if [ -n "$hlpacks" ]; then
1581 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1582 eval ln -f "$(printf '"objects/pack/pack-%s.pack" ' $hlpacks)" \
1583 "$(printf '"objects/pack/pack-%s.idx" ' $hlpacks)" \
1584 '"$cfg_reporoot/$fork.git/objects/pack/"'
1585 runupdate=1
1587 # Match upacks in repack/alt area if any
1588 if [ -n "$upacks" ]; then
1589 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1590 eval ln -f "$(printf '"repack/alt/pack/pack-%s_u.pack" ' $upacks)" \
1591 "$(printf '"repack/alt/pack/pack-%s_u.idx" ' $upacks)" \
1592 '"$cfg_reporoot/$fork.git/objects/pack/"'
1593 runupdate=1
1595 if ! [ -e "$cfg_reporoot/$fork.git/.needsgc" ]; then
1596 # Trigger a mini gc in the fork if it now has too many packs
1597 fpackcnt="$(list_packs --quiet --count --exclude-no-idx --exclude-keep "$cfg_reporoot/$fork.git/objects/pack")" || :
1598 if [ -n "$fpackcnt" ] && [ "$fpackcnt" -ge 20 ]; then
1599 >"$cfg_reporoot/$fork.git/.needsgc"
1602 [ -z "$runupdate" ] || git --git-dir="$cfg_reporoot/$fork.git" update-server-info
1603 # Update the fork's lastparentgc date (must be more recent than $gcstart)
1604 git --git-dir="$cfg_reporoot/$fork.git" config gitweb.lastparentgc "$lastparentgc"
1605 done
1608 # Now move any primary/supplementary packs back into objects/pack
1609 # then drop any "unfreshened" redundant packs and clear repack/alt
1611 # First make sure the primary pack(s) have the most recent mod time
1612 if [ -n "$packs" ]; then
1613 [ -z "$spacks" ] || sleep 1
1614 printf 'repack/alt/pack/pack-%s.pack\n' $packs | xargs touch -c 2>/dev/null || :
1617 # Move the packs into place but with a _f suffix and a .keep file for now
1618 for pack in $packs $spacks; do
1619 rename_pack "repack/alt/pack/pack-$pack" "objects/pack/pack-${pack}_f"
1620 [ -e "objects/pack/pack-${pack}_f.keep" ] ||
1621 echo "final" >"objects/pack/pack-${pack}_f.keep"
1622 done
1624 # It's possible that one of the $oldpacks had a .bitmap, got renamed (along
1625 # with its .bitmap) and then got "freshened" causing us to not remove it
1626 # However, if $wbmopt is set we most likely now have TWO .bitmap packs!
1627 # This can produce ugly warnings we don't want and possibly get the wrong
1628 # bitmap used since only one .bitmap file can ever be used by Git.
1629 # If this has happened, the .bitmap we want to discard will always have
1630 # an _r suffix so we can just zap any such now since it will leave the pack.
1631 [ -z "$wbmopt" ] || rm -f objects/pack/pack-*_r.bitmap || :
1633 # Remove the redundant packs that have not since been "freshened"
1634 # This does not completely eliminate the race condition window (Girocco's own
1635 # activites -- gc/fetch/receive are immune to the race) but it substantially
1636 # shrinks it down to just the time after the find but before the following rm
1637 >repack/oldpacks
1638 [ -z "$oldpacks" ] ||
1639 printf 'objects/pack/%s.pack\n' $oldpacks |
1640 LC_ALL=C sort >repack/oldpacks
1641 find -L objects/pack -maxdepth 1 -type f -name "pack-$octet20*.pack" -newer .gc_in_progress -print |
1642 LC_ALL=C sort >repack/freshened
1643 deadpacks="$(LC_ALL=C join -v 1 repack/oldpacks repack/freshened | LC_ALL=C sed 's/\.pack$//')"
1644 [ -z "$deadpacks" ] ||
1645 eval echo "$(printf '"%s".* ' $deadpacks)" | xargs rm -f || :
1647 # No need for this anymore
1648 rm -rf repack/alt objects/pack/repack
1649 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
1652 ## Phase IV
1655 progress "~ [$proj] running gc prune-packed"
1657 # We do not want the redundant packs or any new "--keep-unreachable" pack(s) to be
1658 # present while running prune-packed. We try to guarantee that any loose object
1659 # (or any object present in a pack with an _l suffix which was created by mini gc)
1660 # that's unreachable persists for at least one $Girocco::Config::min_gc_interval
1661 # (not withstanding administrator interference to force earlier gc to occur).
1662 # If we were to include the redundant/keep-unreachable pack(s) when running
1663 # prune-packed and a loose unreachable object happened to be duplicated in one
1664 # of them we would end up removing it too soon and void our guarantee.
1665 git prune-packed $quiet
1667 progress "~ [$proj] running loose objects gc pack-objects ($(date))"
1669 # Although Git v2.10.0 and later support a --pack-loose-unreachable option,
1670 # we MUST NOT use it for these reasons:
1671 # 1) We're not interested in expensive "unreachable" at this point, only "loose"
1672 # 2) It produces simply horrid packs about 3.8x times larger than they should be
1673 # 3) We don't require anything more than Git v1.6.6
1674 # The only way we could see any _o pack files at this point is if one got
1675 # "freshened" while we were running gc. If that happens then it gets to live on
1676 # until the next full gc and we need to include it in the loose repack here.
1677 lpacks="$(list_packs --exclude-no-idx --exclude-no-sfx _l --exclude-no-sfx _o --quiet objects/pack |
1678 run_combine_packs --replace --names --loose --weak-naming --non-empty --honor-pack-keep \
1679 --all-progress-implied ${quiet:---progress} $packopts $newdeltas "$@")"
1681 if [ -n "$lpacks" ]; then
1682 # Make sure any primary pack(s) have a more recent mod time than "unreachable" objects packs
1683 if [ -n "$packs" ]; then
1684 sleep 1
1685 printf 'objects/pack/pack-%s_f.pack\n' $packs | xargs touch -c 2>/dev/null || :
1687 # We need to identify these packs later so we don't combine_packs them
1688 for objpack in $lpacks; do
1689 rename_pack "objects/pack/pack-$objpack" "objects/pack/pack-${objpack}_o" || :
1690 done
1693 # Polish up the final packs now
1694 rm -f objects/pack/pack-*_f.keep
1695 for pack in $packs $spacks; do
1696 rename_pack "objects/pack/pack-${pack}_f" "objects/pack/pack-$pack"
1697 done
1699 if [ -n "$lpacks" ]; then
1700 # Finally zap the corresponding loose objects
1701 progress "~ [$proj] running packed loose objects gc prune-packed"
1702 git prune-packed $quiet
1705 ! [ -e .gc_failed ] || exit 1
1706 # These, if they exist, are now meaningless and need to be removed
1707 rm -f gfi-packs .needsgc .needspack .needspackgc
1709 # Make sure this stays up to date
1710 git update-server-info
1712 # We must make loose objects group writable so that they
1713 # can be freshened by other pushers. Technically we need only do this for
1714 # push projects but to enable mirror projects to be more easily converted to
1715 # push projects, we go ahead and do it for all projects.
1716 # By the time we get here we really shouldn't have any of these, but just in case.
1717 { find -L objects/$octet -type f -name "$octet19*" -exec chmod ug+w '{}' + || :; } 2>/dev/null
1719 # darcs mirrors have a xxx.log file that will grow endlessly
1720 # if this is a mirror and the file exists, shorten it to 10000 lines
1721 # also take this opportunity to optimize the darcs repo
1722 if ! [ -e .nofetch ] && [ -n "$cfg_mirror" ]; then
1723 url="$(config_get baseurl)" || :
1724 case "$url" in darcs://* | darcs+http://* | darcs+https://*)
1725 if [ -n "$cfg_mirror_darcs" ]; then
1726 url="${url%/}"
1727 basedarcs="$(basename "${url#darcs*:/}")"
1728 if [ -f "$basedarcs.log" ]; then
1729 tail -n 10000 "$basedarcs.log" >"$basedarcs.log.$$"
1730 mv -f "$basedarcs.log.$$" "$basedarcs.log"
1732 if [ -d "$basedarcs.darcs" ]; then
1734 cd "$basedarcs.darcs"
1735 # without show_progress suppress non-error output
1736 [ "${show_progress:-0}" != "0" ] || exec >/dev/null
1737 # Note that this does not optimize _darcs/inventories/ :(
1738 darcs optimize || :
1742 esac
1745 # Create a matching .bndl header file for the all-in-one pack we just created
1746 # but only if we're not a fork (otherwise the bundle would not be complete)
1747 # and we are running at least Git version 1.7.2 (pack_is_complete always fails otherwise)
1748 if [ -n "$makebndl" ] && [ -n "$var_have_git_172" ]; then
1749 # There should only be one pack in $packs but do some checking...
1750 # The one we just created will have a .idx and will NOT have a .keep
1751 progress "~ [$proj] creating downloadable bundle header"
1752 pkbase=
1753 pkhead=
1754 IFS= read -r curhead <repack/HEAD.orig || :
1756 [ -s "objects/pack/pack-$packs.pack" ] &&
1757 [ -s "objects/pack/pack-$packs.idx" ] &&
1758 ! [ -e "objects/pack/pack-$packs.keep" ] &&
1759 pkhead="$(pack_is_complete "$PWD/objects/pack/pack-$packs.pack" \
1760 "$PWD/repack/packed-refs.orig" "$curhead")"
1761 then
1762 pkbase="objects/pack/pack-$packs"
1764 if [ -n "$pkbase" ] && [ -n "$pkhead" ]; then
1766 symref=
1767 case "$curhead" in "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
1768 symref="${curhead#ref:}"
1769 symref="${symref# }"
1770 esac
1771 bndlurl=
1772 [ -z "$cfg_httpbundleurl" ] || bndlurl=" url=$cfg_httpbundleurl/$proj.git/clone.bundle"
1773 echo "# v2 git bundle"
1774 LC_ALL=C sed -ne "/^$octet20$hexdig* refs\/[^ $tab]*\$/ p" <repack/packed-refs.orig
1775 if [ -n "$symref" ]; then
1776 printf "$pkhead HEAD\0symref=HEAD:%s%s\n" "$symref" "$bndlurl"
1777 else
1778 if [ -n "$bndlurl" ]; then
1779 printf "$pkhead HEAD\0%s\n" "${bndlurl# }"
1780 else
1781 echo "$pkhead HEAD"
1784 echo ""
1785 } >"$pkbase.bndl"
1786 bndletag="$("$cfg_basedir/bin/rangecgi" --etag -m 1 "$pkbase.bndl" "$pkbase.pack")" || :
1787 bndlsha="$(printf '%s' "$bndletag" | git hash-object --stdin)" || :
1788 if [ -n "$bndletag" ]; then
1789 case "$bndlsha" in $octet20*)
1790 bndlshatrailer="${bndlsha#????????}"
1791 bndlshaprefix="${bndlsha%$bndlshatrailer}"
1792 bndlname="$(TZ=UTC date +%Y%m%d_%H%M%S)-${bndlshaprefix:-0}"
1793 [ -d bundles ] || mkdir bundles
1794 echo "${pkbase#objects/pack/}.bndl" >"bundles/$bndlname"
1795 echo "${pkbase#objects/pack/}.pack" >>"bundles/$bndlname"
1796 ln -s -f -n "$bndlname" bundles/latest
1797 esac
1802 # Record the size of this repo as the sum of its clone packed-refs + *.pack sizes as 1024-byte blocks
1803 eval "reposizek=$(( $(
1804 echo 0 $(du -k repack/packed-refs.orig $(printf 'objects/pack/pack-%s.pack ' $packs) 2>/dev/null |
1805 LC_ALL=C awk '{print $1}') |
1806 LC_ALL=C sed -e 's/ / + /g') ))"
1807 config_set_raw girocco.reposizek "${reposizek:-0}"
1809 read -r rsighash <repack/packed-refs.sighash || :
1810 read -r repacksig <repack/repack.sighash || :
1812 # Now we're finally done with this
1813 rm -rf repack
1815 # Update various "signature" hashes used to help determine whether or
1816 # not it's okay to skip gc in the future (because there's nothing to do)
1818 psighash="$(if [ -n "$packs" ] || [ -n "$spacks" ]; then
1819 printf 'pack-%s.pack\n' $packs $spacks
1820 fi | LC_ALL=C sort | sig_hash_stdin)"
1821 config_set_raw girocco.gcsig.packs "$psighash"
1822 config_set_raw girocco.gcsig.refs "$rsighash"
1823 config_set_raw girocco.gcsig.repack "$repacksig"
1825 # We use $gcstart here to avoid a race where a push occurs during the gc itself
1826 # and the next future gc could be incorrectly skipped if we used the current
1827 # timestamp here instead
1828 config_set lastgc "$gcstart"
1829 rm -f "$lockf"
1831 progress "- [$proj] garbage check ($(date))"